
EndPoint : https://query.wikidata.org/

// FILTER(STRSTARTS(?humanLabel, "Mr. ")).

// wdt:P136 -> Genre du film
// wdt:P921 -> main subject
// Liste de film ayant pour sujet l interlligence artificiel
SELECT ?film ?filmLabel
WHERE
{
  ?film wdt:P31 wd:Q11424 .
  ?film rdfs:label ?filmLabel .
  ?film wdt:P921 wd:Q11660
  FILTER(LANG(?filmLabel) = "en" )
}

// Film commencant par "The Matrix"
SELECT ?film ?filmLabel
WHERE
{
  ?film wdt:P31 wd:Q11424 .
  ?film rdfs:label ?filmLabel .
  FILTER(LANG(?filmLabel) = "en" ) .
  FILTER(STRSTARTS(?filmLabel, "The Matrix"))
}

// Film commencant par "The Matrix" et lié à un element
SELECT ?film ?filmLabel ?linked ?linkedLabel
WHERE
{
  ?film wdt:P31 wd:Q11424 .
  ?film rdfs:label ?filmLabel .
  ?film ?link ?linked .
  ?linked rdfs:label ?linkedLabel .
  FILTER(LANG(?filmLabel) = "en" ) .
  FILTER(LANG(?linkedLabel) = "en" ) .
  FILTER(STRSTARTS(?filmLabel, "The Matrix"))
}

// Tout les éléments liées au film "The Matrix"
SELECT ?film ?filmLabel ?link ?linkedElement ?linkedLabel
WHERE
{
  ?film wdt:P31 wd:Q11424 .
  ?film rdfs:label ?filmLabel .
  ?film ?link ?linkedElement .
  ?linkedElement rdfs:label ?linkedLabel .
  FILTER(LANG(?filmLabel) = "en" ) .
  FILTER(LANG(?linkedLabel) = "en" ) .
  FILTER(STRENDS(?filmLabel, "The Matrix"))
}

// Tout les éléments liées au film "The Matrix" avec type d'élément
SELECT ?film ?filmLabel ?link ?linkedEl ?linkedLabel ?linkedType
WHERE
{
  ?film wdt:P31 wd:Q11424 .
  ?film rdfs:label ?filmLabel .
  ?film ?link ?linkedEl .
  ?linkedEl rdfs:label ?linkedLabel .
  ?linkedEl wdt:P31 ?linkedType
  FILTER(LANG(?filmLabel) = "en" ) .
  FILTER(LANG(?linkedLabel) = "en" ) .
  FILTER(STRENDS(?filmLabel, "The Matrix"))
}

// Tout les éléments liées au film "The Matrix" avec type d'élément grouper
SELECT ?film ?filmLabel ?link ?linkedEl ?linkedLabel (group_concat(distinct ?linkedType;separator=";") as ?linkedTypes)
WHERE
{
  ?film wdt:P31 wd:Q11424 .
  ?film rdfs:label ?filmLabel .
  ?film ?link ?linkedEl .
  ?linkedEl rdfs:label ?linkedLabel .
  ?linkedEl wdt:P31 ?linkedType
  FILTER(LANG(?filmLabel) = "en" ) .
  FILTER(LANG(?linkedLabel) = "en" ) .
  FILTER(STRENDS(?filmLabel, "The Matrix"))
}
GROUP BY ?film ?filmLabel ?link ?linkedEl ?linkedLabel

//
SELECT ?film ?filmLabel (group_concat(distinct ?link;separator=";") as ?links) ?linkedEl ?linkedLabel (group_concat(distinct ?linkedType;separator=";") as ?linkedTypes)
WHERE
{
  ?film wdt:P31 wd:Q11424 .
  ?film rdfs:label ?filmLabel .
  ?film ?link ?linkedEl .
  ?linkedEl rdfs:label ?linkedLabel .
  ?linkedEl wdt:P31 ?linkedType
  FILTER(LANG(?filmLabel) = "en" ) .
  FILTER(LANG(?linkedLabel) = "en" ) .
  FILTER(STRENDS(?filmLabel, "The Matrix"))
}
GROUP BY ?film ?filmLabel ?linkedEl ?linkedLabel

// Tout les lments lies au film "The Matrix" avec type d'lment et type de lien group + requte en double sens
SELECT (<http://www.wikidata.org/entity/Q296883> as ?film)  ?filmLabel (group_concat(distinct ?link;separator=";") as ?links) ?linkedEl ?linkedLabel (group_concat(distinct ?linkedType;separator=";") as ?linkedTypes)
WHERE {
		{
			<http://www.wikidata.org/entity/Q296883> rdfs:label ?filmLabel .
			?linkedEl ?link <http://www.wikidata.org/entity/Q296883> .
			?linkedEl rdfs:label ?linkedLabel .
			?linkedEl wdt:P31 ?linkedType
			FILTER(LANG(?filmLabel) = "en" ) .   FILTER(LANG(?linkedLabel) = "en" ) .
			FILTER(?link = <http://www.wikidata.org/prop/direct/*> || ?link = <http://www.wikidata.org/prop/direct/P921> || ?link = <http://www.wikidata.org/prop/direct/P136> || ?link = <http://www.wikidata.org/prop/direct/P57> || ?link = <http://www.wikidata.org/prop/direct/P161> || ?link = <http://www.wikidata.org/prop/direct/P162> || ?link = <http://www.wikidata.org/prop/direct/P86> || ?link = <http://www.wikidata.org/prop/direct/P58>) .
		}
		UNION
		{
			<http://www.wikidata.org/entity/Q296883> rdfs:label ?filmLabel .
			<http://www.wikidata.org/entity/Q296883> ?link ?linkedEl .
			?linkedEl rdfs:label ?linkedLabel .
			?linkedEl wdt:P31 ?linkedType
			FILTER(LANG(?filmLabel) = "en" ) .   FILTER(LANG(?linkedLabel) = "en" ) .
			FILTER(?link = <http://www.wikidata.org/prop/direct/*> || ?link = <http://www.wikidata.org/prop/direct/P921> || ?link = <http://www.wikidata.org/prop/direct/P136> || ?link = <http://www.wikidata.org/prop/direct/P57> || ?link = <http://www.wikidata.org/prop/direct/P161> || ?link = <http://www.wikidata.org/prop/direct/P162> || ?link = <http://www.wikidata.org/prop/direct/P86> || ?link = <http://www.wikidata.org/prop/direct/P58>) .
		}
} GROUP BY ?film ?filmLabel ?linkedEl ?linkedLabel

// Tout les lments lies au film "The Matrix" avec type d'lment et type de lien group + requte en double sens avec en plus l'affichage du sens
SELECT (<http://www.wikidata.org/entity/Q296883> as ?film)  ?filmLabel (group_concat(distinct ?link;separator=";") as ?links) ?linkedEl ?linkedLabel (group_concat(distinct ?linkedType;separator=";") as ?linkedTypes) ?inverse
WHERE {
		{
			<http://www.wikidata.org/entity/Q296883> rdfs:label ?filmLabel .
			?linkedEl ?link <http://www.wikidata.org/entity/Q296883> .
			?linkedEl rdfs:label ?linkedLabel .
			?linkedEl wdt:P31 ?linkedType .
            BIND(false AS ?inverse) .
			FILTER(LANG(?filmLabel) = "en" ) .   FILTER(LANG(?linkedLabel) = "en" ) .
			FILTER(?link = <http://www.wikidata.org/prop/direct/*> || ?link = <http://www.wikidata.org/prop/direct/P921> || ?link = <http://www.wikidata.org/prop/direct/P136> || ?link = <http://www.wikidata.org/prop/direct/P57> || ?link = <http://www.wikidata.org/prop/direct/P161> || ?link = <http://www.wikidata.org/prop/direct/P162> || ?link = <http://www.wikidata.org/prop/direct/P86> || ?link = <http://www.wikidata.org/prop/direct/P58>) .
		}
		UNION
		{
			<http://www.wikidata.org/entity/Q296883> rdfs:label ?filmLabel .
			<http://www.wikidata.org/entity/Q296883> ?link ?linkedEl .
			?linkedEl rdfs:label ?linkedLabel .
			?linkedEl wdt:P31 ?linkedType .
            BIND(true AS ?inverse) .
			FILTER(LANG(?filmLabel) = "en" ) .   FILTER(LANG(?linkedLabel) = "en" ) .
			FILTER(?link = <http://www.wikidata.org/prop/direct/*> || ?link = <http://www.wikidata.org/prop/direct/P921> || ?link = <http://www.wikidata.org/prop/direct/P136> || ?link = <http://www.wikidata.org/prop/direct/P57> || ?link = <http://www.wikidata.org/prop/direct/P161> || ?link = <http://www.wikidata.org/prop/direct/P162> || ?link = <http://www.wikidata.org/prop/direct/P86> || ?link = <http://www.wikidata.org/prop/direct/P58>) .
		}
} GROUP BY ?film ?filmLabel ?linkedEl ?linkedLabel ?inverse

// Requte finale (avec image)
SELECT (<http://www.wikidata.org/entity/Q296883> as ?film)  ?filmLabel (group_concat(distinct ?link;separator=";") as ?links) ?linkedEl ?linkedLabel (group_concat(distinct ?linkedType;separator=";") as ?linkedTypes) ?inverse ?image ?linkedImage
WHERE {
		{
			<http://www.wikidata.org/entity/Q296883> rdfs:label ?filmLabel .
			?linkedEl ?link <http://www.wikidata.org/entity/Q296883> .
			?linkedEl rdfs:label ?linkedLabel .
			?linkedEl wdt:P31 ?linkedType .
            OPTIONAL { <http://www.wikidata.org/entity/Q296883> wdt:P18 ?image }
            OPTIONAL { ?linkedEl wdt:P18 ?linkedImage }
            BIND(false AS ?inverse) .
			FILTER(LANG(?filmLabel) = "en" ) .   FILTER(LANG(?linkedLabel) = "en" ) .
			FILTER(?link = <http://www.wikidata.org/prop/direct/*> || ?link = <http://www.wikidata.org/prop/direct/P921> || ?link = <http://www.wikidata.org/prop/direct/P136> || ?link = <http://www.wikidata.org/prop/direct/P57> || ?link = <http://www.wikidata.org/prop/direct/P161> || ?link = <http://www.wikidata.org/prop/direct/P162> || ?link = <http://www.wikidata.org/prop/direct/P86> || ?link = <http://www.wikidata.org/prop/direct/P58>) .
		}
		UNION
		{
			<http://www.wikidata.org/entity/Q296883> rdfs:label ?filmLabel .
			<http://www.wikidata.org/entity/Q296883> ?link ?linkedEl .
			?linkedEl rdfs:label ?linkedLabel .
			?linkedEl wdt:P31 ?linkedType .
            OPTIONAL { <http://www.wikidata.org/entity/Q296883> wdt:P18 ?image }
            OPTIONAL { ?linkedEl wdt:P18 ?linkedImage }
            BIND(true AS ?inverse) .
			FILTER(LANG(?filmLabel) = "en" ) .   FILTER(LANG(?linkedLabel) = "en" ) .
			FILTER(?link = <http://www.wikidata.org/prop/direct/*> || ?link = <http://www.wikidata.org/prop/direct/P921> || ?link = <http://www.wikidata.org/prop/direct/P136> || ?link = <http://www.wikidata.org/prop/direct/P57> || ?link = <http://www.wikidata.org/prop/direct/P161> || ?link = <http://www.wikidata.org/prop/direct/P162> || ?link = <http://www.wikidata.org/prop/direct/P86> || ?link = <http://www.wikidata.org/prop/direct/P58>) .
		}
} GROUP BY ?film ?filmLabel ?linkedEl ?linkedLabel ?inverse ?image ?linkedImage

// Recherche d\'un film
SELECT ?element ?elementLabel
WHERE
{
  ?element wdt:P31 wd:Q11424 .
  ?element rdfs:label ?elementLabel .
  FILTER(LANG(?elementLabel) = "en" )
}
